<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier extends AbstractStructArrayBase
{
    /**
     * The InternalServiceSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalServiceSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier
     * @uses ArrayOfJP_InternalSupplier::setInternalServiceSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalServiceSupplier
     */
    public function __construct(array $internalServiceSupplier = array())
    {
        $this
            ->setInternalServiceSupplier($internalServiceSupplier);
    }
    /**
     * Get InternalServiceSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalServiceSupplier()
    {
        return $this->InternalServiceSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setInternalServiceSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInternalServiceSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInternalServiceSupplierForArrayConstraintsFromSetInternalServiceSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InternalSupplierInternalServiceSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplierInternalServiceSupplierItem instanceof \StructType\JP_InternalSupplier) {
                $invalidValues[] = is_object($arrayOfJP_InternalSupplierInternalServiceSupplierItem) ? get_class($arrayOfJP_InternalSupplierInternalServiceSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_InternalSupplierInternalServiceSupplierItem), var_export($arrayOfJP_InternalSupplierInternalServiceSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InternalServiceSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InternalServiceSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalServiceSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier
     */
    public function setInternalServiceSupplier(array $internalServiceSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($internalServiceSupplierArrayErrorMessage = self::validateInternalServiceSupplierForArrayConstraintsFromSetInternalServiceSupplier($internalServiceSupplier))) {
            throw new \InvalidArgumentException($internalServiceSupplierArrayErrorMessage, __LINE__);
        }
        $this->InternalServiceSupplier = $internalServiceSupplier;
        return $this;
    }
    /**
     * Add item to InternalServiceSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier
     */
    public function addToInternalServiceSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalServiceSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InternalServiceSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalServiceSupplier
     */
    public function getAttributeName()
    {
        return 'InternalServiceSupplier';
    }
}
